import React, { Component } from 'react';
import * as PropTypes from 'prop-types';

import { VirtualTable } from '@devexpress/dx-react-grid-material-ui';

const VirtualTableCell = VirtualTable.Cell;

class DataTableCell extends Component {
    shouldComponentUpdate(nextProps) {
        const {
            className,
            style,
            value,
        } = this.props;

        if (nextProps.value !== value ||
            nextProps.className !== className ||
            JSON.stringify(nextProps.style) !== JSON.stringify(style)) {
            return true;
        }

        return false;
    }

    render() {
        console.log('DATA TABLE RXG: TABLE CELL: RENDER: ', this.props); // eslint-disable-line

        return (
            <VirtualTableCell { ...this.props } />
        );
    };
}

DataTableCell.propTypes = {
    children: PropTypes.oneOfType([
        PropTypes.array,
        PropTypes.node,
        PropTypes.element,
    ]),
    className: PropTypes.string,
    colSpan: PropTypes.number,
    column: PropTypes.shape({
        name: PropTypes.string,
        title: PropTypes.string,
    }),
    row: PropTypes.object,
    rowSpan: PropTypes.number,
    style: PropTypes.object,
    tableColumn: PropTypes.object,
    tableRow: PropTypes.object,
    value: PropTypes.oneOfType([
        PropTypes.string,
        PropTypes.number,
    ]).isRequired,
};

DataTableCell.defaultProps = {};

export default DataTableCell;
